質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.13%

onLocationChanged()が呼び出されない

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 4,493

atatatatata

score 13

onLocationChanged()が呼ばれないのですが、どうすればいいでしょうか?

@Override
public void onConnected(Bundle bundle) {}
は、しっかり呼ばれています。

原因がわからなかったため、シンプルな、https://akira-watson.com/android/fusedlocationproviderapi.html
このURLのサイトをコピペしてアプリを別に作成し、起動させましたが、onLocationChanged()が呼ばれることはありませんでした。どうぞよろしくお願いします。

コードは上記のサイトのコピペのものを使用しているため、字数的に、Manifest.xmlと、gradleファイルのみ記載しました。

すべてのcom.android.supportライブラリは、まったく同じバージョンの仕様を使用する必要があります(ミックスバージョンはランタイムクラッシュにつながる可能性があります)。バージョン25.0.1,24.0.0が見つかりました。例としては、com.android.support:support-v4:25.0.1およびcom.android.support:palette-v7:24.0.0 less ...(⌘F1)
互換性がない、またはバグにつながるライブラリやツールやライブラリの組み合わせがいくつかあります。このような非互換性の1つは、Androidサポートライブラリの最新バージョン(または特にtargetSdkVersionよりも低いバージョン)ではないバージョンでコンパイルされています。

こんなエラーが出てます。

Manifest.xml

<?xml version="1.0" encoding="utf-8"?>
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    package="com.example.android.sample.myapplication">

    <!-- ^^^ The above package name should modify to your project name. -->

    <uses-permission android:name="android.permission.ACCESS_FINE_LOCATION" />
    <uses-permission android:name="android.permission.ACCESS_COARSE_LOCATION" />

    <application
        android:allowBackup="true"
        android:icon="@mipmap/ic_launcher"
        android:label="@string/app_name"
        android:supportsRtl="true"
        android:theme="@style/AppTheme">
        <meta-data
            android:name="com.google.android.gms.version"
            android:value="@integer/google_play_services_version" />

        <activity android:name=".MainActivity">
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />

                <category android:name="android.intent.category.LAUNCHER" />
            </intent-filter>
        </activity>
        <activity android:name=".LocationActivity"></activity>
    </application>

</manifest>

Gradleアプリ

apply plugin: 'com.android.application'
android {
    compileSdkVersion 25
    buildToolsVersion "25.0.1"

    defaultConfig {
        applicationId "com.example.android.sample.myapplication"
        minSdkVersion 24
        targetSdkVersion 25
        versionCode 1
        versionName "1.0"
        testInstrumentationRunner "android.support.test.runner.AndroidJUnitRunner"
        multiDexEnabled true
    }
    buildTypes {
        release {
            minifyEnabled false
            proguardFiles getDefaultProguardFile('proguard-android.txt'), 'proguard-rules.pro'
        }
    }
}

dependencies {
    compile fileTree(include: ['*.jar'], dir: 'libs')
    androidTestCompile('com.android.support.test.espresso:espresso-core:2.2.2', {
        exclude group: 'com.android.support', module: 'support-annotations'
    })
    compile 'com.android.support:appcompat-v7:25.0.1'
    testCompile 'junit:junit:4.12'
    compile 'com.google.android.gms:play-services:9.6.1'
    compile 'com.android.support:support-v4:25.0.1'
    compile 'com.android.support:support-v13:25.0.1'
}

gradle

// Top-level build file where you can add configuration options common to all sub-projects/modules.

buildscript {
    repositories {
        jcenter()
    }
    dependencies {
        classpath 'com.android.tools.build:gradle:2.3.3'

        // NOTE: Do not place your application dependencies here; they belong
        // in the individual module build.gradle files
    }
}

allprojects {
    repositories {
        jcenter()
    }
}

task clean(type: Delete) {
    delete rootProject.buildDir
}


イメージ説明

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • yona

    2017/07/26 10:01

    メソッドが呼ばれないのはどのようにして確認しましたか?

    キャンセル

  • atatatatata

    2017/07/26 10:14

    Logで確認しました。そのたアプリの説明を加えました。どうぞよろしくお願いします。

    キャンセル

回答 1

checkベストアンサー

+1

importを確認しましょう

import com.google.android.gms.location.LocationListener;

import android.location.LocationListener;
はGPSのみの場合です

backgroundでの例はこちらにもあります
https://akira-watson.com/android/multi-runtime-permission.html


追記:
Google APIs for Android|最終更新日: 7月 26, 2017
こちらのリリースノートでは
FusedLocationProviderClient
が追加されたようです。

Google Play services updated 11 以上ではこれを使っていく方針なのでしょう
これを使うだけならばいいのですが、他のライブラリーも引きずられます
つまり、新しいビルドをする場合はこれを使う必要がある...ようです(多分)

FusedLocationProviderClient
をググっても日本語のサイトは皆無なので(韓国語、中国語はあります)
Googleのサンプル及びそのた英語の内容を読み進めるしかないでしょうね
今のところ

しかし、これは古いAPIはFusedLocationProviderApi
SDK26からは FusedLocationProviderClient
を使うという切り分けをしないといけないのか?!
という疑問が出てきます(寒気...)

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/07/28 15:20

    先ほどいただいたサンプルを実行できました。これを変更して使ってみます。

    キャンセル

  • 2017/07/28 16:19

    http://d.hatena.ne.jp/itog/20130526/1369580357
    このようなサイトを見つけたのですが、ブロバイダと、行動認識があるのですが、先ほど教えていただいた、行動認識で、位置情報を取得できるのでしょうか?

    キャンセル

  • 2017/07/29 14:09

    ありがとうございます。できました。
    精度も調整してみます。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.13%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる